#include <ez8.h>
#include "irphy.h"

#define CLOCK_FREQUENCY         18432000UL
#define BAUDRATE                (CLOCK_FREQUENCY / (9600UL * 16UL))

#define TIMER_CONTINUOUS        0x01
//#define TIMER_RESET_HIGH        0x48
#define TIMER_RESET_HIGH        0xFF
#define TIMER_RESET_LOW         0x00
#define TIMER_ENABLE            0x80

/*
static char g_timeout = 0;
static unsigned short __timeout = 0;

#pragma interrupt
void isr_timer3()
{
  if(--__timeout == 0)
  {
    g_timeout = 1;
  }
}
*/

static void enable_timer3(unsigned short msec)
{
//  __timeout = msec;

//  DI();

  // Set ISR
//  SET_VECTOR(TIMER3, isr_timer3); 

  T3H   = 0x00; 
  T3L   = 0x01;
  T3RH  = TIMER_RESET_HIGH;
  T3RL  = TIMER_RESET_LOW;
  T3CTL = TIMER_ENABLE|TIMER_CONTINUOUS;

  // Set the timer interrupt priority high
//  IRQ2ENH |= 0x80;
//  IRQ2ENL |= 0x80;

//  EI();
}

static void disable_timer3()
{
  T3CTL &= ~TIMER_ENABLE;
}

void irphy_reset(void)
{
  U0BRH = (unsigned char)((0xFF00&BAUDRATE)>>0x08);
  U0BRL = (unsigned char) (0x00FF&BAUDRATE);

  /* Enable UART0 alternate function */
  PAAF |= 0x30;

  /* Enable UART0 receive */
  U0CTL0 = 0x40;

  /* Enable UART IR */
  U0CTL1 = 0x01;
}

void irphy_send(uint8_t v)
{
  /* Set UART0 to transmit */
  U0CTL0 = 0x80;

  /* Wait for transmit buffer to be available */
  while((U0STAT0 & 0x04) == 0) { } 
  U0TXD = v;
  while((U0STAT0 & 0x02) == 0) { }

  /* Set UART0 to receive */
  U0CTL0 = 0x40;
}

uint8_t irphy_wait(int16_t timeout)
{
//  g_timeout = 0;
  unsigned char done = 0;
  if(timeout != -1)
  {
    enable_timer3(timeout);
//    while(!(U0STAT0 & 0x80) && !g_timeout)
    while(!(U0STAT0 & 0x80) && !done)
    {
      if(T3H > 0x48)
      {
        if(--timeout == 0)
        {
          done = 1;
        }
        else
        {
          T3H = 0x00;
          T3L = 0x01;
        }
      }
    }
    disable_timer3();
  }
  else
  {
    while(!(U0STAT0 & 0x80))
    {
    }
  }

  return (U0STAT0 & 0x80) ? 1 : 0;
}

uint8_t irphy_receive(void)
{
  return U0RXD;
}

